#include <stdio.h>
#include "pdf2pdfapi_c.h"

int main(int argc, char* argv[])
{

    TPdf2Pdf* pDocument;
    int       iRetVal = 0;

    Pdf2PdfInitialize();

    if (!Pdf2PdfGetLicenseIsValid())
    {
        printf("No valid license key found.\n");
        return 10;
    }

    pDocument = Pdf2PdfCreateObject();

    // Optional: Apply a Digital Signature
    
	Pdf2PdfSetCertificateNameA(pDocument, "Taro Yamada");
//	Pdf2PdfSetIssuerA(pDocument, "CA21-5");
//	Pdf2PdfSetSignatureSerialNumberA(pDocument, "15 a3");
	Pdf2PdfSetTimeStampURLA(pDocument,"http://ca21.trustss.jp/tsa/");
	Pdf2PdfSetSignatureImageFileNameA(pDocument, "hankol.png");
    

    /* Optional: Set Color Profiles
     * 
     * If no profiles are set, default profile are selected.
     */

    /*
    FILE*     file;

    char* csRGB = "C:\winnt\system32\spool\drivers\color\sRGB Color Space Profile.icm"
    char* cCMYK = "C:\winnt\system32\spool\drivers\color\USWebCoatedSWOP.icc";

    // Check if color profile file exists
    if (file = fopen(csRGB, "r"))
    {
        fclose(file);
            Pdf2PdfSetOutputIntentProfileA(pDocument, csRGB);
    }
    else
    {
        printf("Warning, file not found: %s\n", csRGB);
        iRetVal = 1;
    }         
    
    */

    // Enable Report Summary
	Pdf2PdfSetConvertAlways(pDocument,1);
	Pdf2PdfSetReportDetails(pDocument, 1);
	Pdf2PdfSetReportSummary(pDocument, 1);
	Pdf2PdfSetPostAnalyze(pDocument, 1);
	Pdf2PdfSetCompliance(pDocument, ePDFA1a);

    // Convert
    if (!Pdf2PdfConvertA(pDocument, "Receipt2.pdf", "", "Receipt2ti.pdf", "Receipt2.log"))
    {
		printf("Analysis in PDF/A compliant or output file could not be created.\n");
		switch(iRetVal=Pdf2PdfGetErrorCode(pDocument)){
		case PDF_E_FILEOPEN:
			printf("t@CJȂ\n");
			break;
		case PDF_E_FILECREATE:
			printf("t@C쐬łȂ\n");
			break;
		case PDF_E_STOPPED:
			printf("͂~ꂽ\n");
			break;
		default:
			printf("ϊG[ (0x%X)\n", iRetVal);
			break;
		}
	}else{
		switch(iRetVal=Pdf2PdfGetErrorCode(pDocument)){
		case PDF_E_CONVERSION:
			printf("ϊŃG[\n");
			break;
		case PDF_E_POSTANALYSIS:
			printf("ϊŉ̓G[\n");
			break;
		case PDF_E_CONFORMANCE:
			printf("vꂽWɏĂȂ\n");
			break;
		case SIG_CREA_E_CERT:
			printf("ؖȂ\n");
			break;
		default:
			printf("|Xg (0x%X)\n", iRetVal);
			break;
		}
    }

	// Cleanup
    Pdf2PdfDestroyObject(pDocument);
    Pdf2PdfUnInitialize();

    return iRetVal;
}